//Chidori.cs

datablock AudioProfile(ChidoriHitSound)
{
	filename = "./ChidoriStrikeSound.wav";
	description = AudioClosest3d;
	preload = true;
};

//Particles and Emitters

datablock ParticleData(ChidoriSparkParticle)
{
	dragCoefficent = 1.0;
	gravityCoefficient = 0.3;
	inheritedVelFactor = 1.0;
	constantAcceleration = 0.1;
	lifetimeMS = 300;
	lifetimeVarianceMS = 100;
	textureName = "./Lightning";
	spinSpeed = 100;
	spinRandomMin = 10;
	spinRandomMax = 1000;
	colors[0] = "0.2 0.4 1.0 0.9";
	colors[1] = "0.1 0.3 1.0 1.0";
	colors[2] = "0.0 0.2 9.0 0.3";
	sizes[0] = 0.89;
	sizes[1] = 0.49;
	sizes[2] = 0.23;
	times[0] = 1.0;
	times[1] = 2.1;
	times[2] = 3.2;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ChidoriSparkEmitter)
{
	ejectionPeriodMS = 3;
	periodVarianceMS = 1;
	ejectionVelocity = 3;
	velocityVariance = 2;
	ejectionOffset = 0.1;
	thetaMin = 45;
	thetaMax = 86;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "ChidoriSparkParticle";

	uiName = "Chidori Spark";
};

datablock ParticleData(ChidoriExplosionParticle)
{
	dragCoefficent = 0.0;
	gravityCoefficient = -0.35;
	inheritedVelFactor = 1.0;
	constantAcceleration = 0.6;
	lifetimeMS = 300;
	lifetimeVarianceMS = 30;
	textureName = "./Lightning";
	spinSpeed = 100;
	spinRandomMin = 10;
	spinRandomMax = 1000;
	colors[0] = "0.2 0.6 1.0 1.0";
	colors[1] = "0.1 0.4 1.0 1.0";
	colors[2] = "0.2 0.2 1.0 0.1";
	sizes[0] = 0.69;
	sizes[1] = 0.58;
	sizes[2] = 0.5;
	times[0] = 1.0;
	times[1] = 2.1;
	times[2] = 3.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ChidoriExplosionEmitter)
{
	ejectionPeriodMS = 2;
	periodVarianceMS = 1;
	ejectionVelocity = 2;
	velocityVariance = 1;
	ejectionOffset = 1.2;
	thetaMin = 86;
	thetaMax = 97;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = "ChidoriExplosionParticle";

	uiName = "Chidori Explosion";
};

datablock ParticleData(ChidoriTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 3000;
	lifetimeVarianceMS   = 805;
	textureName          = "./shine2";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 1.0 0.2 0.4";
	colors[1]     = "1.0 0.2 1.0 0.5";
   colors[2]     = "0.20 1.0 0.20 0.3";
   colors[3]     = "0.4 0.7 1.0 0.5";

	sizes[0]      = 0.75;
	sizes[1]      = 1.12;
   sizes[2]      = 0.35;
 	sizes[3]      = 0.05;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ChidoriTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ChidoriTrailParticle";

   uiName = "Chidori Trail";
};


//Explosion
datablock ExplosionData(ChidoriExplosion)
{
   //explosionShape = "";
   //explosionShape = "./explosionSphere1.dts";
	soundProfile = ChidoriHitSound;



   particleEmitter = ChidoriExplosionEmitter;
   particleDensity = 100;
   particleRadius = 1;

   emitter[0] = ChidoriSparkEmitter;
   emitter[1] = ChidoriTrailEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

  shakeCamera = true;
   camShakeFreq = "30.0 20.0 25.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 5.0;
   camShakeRadius = 2.0;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 3;
   lightStartColor = "0.0 0.6 0.6 0.9";
   lightEndColor = "0.0 0.1 1.0 1";

   damageRadius = 2;
   radiusDamage = 10;

   impulseRadius = 4;
   impulseForce = 11;

   uiname = "Chidori";
};

//projectile
AddDamageType("Chidori",  '<bitmap:add-ons/Weapon_Chidori/CI_Chidori> %1',    '%2 <bitmap:add-ons/Weapon_Chidori/CI_Chidori> %1',1,1);

datablock ProjectileData(ChidoriProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 20;
   directDamageType = $DamageType::Chidori;
   radiusDamageType = $DamageType::Chidori;
   impactImpulse	   = 7;
   verticalImpulse	   = 7;
   explosion           = ChidoriExplosion;
   particleEmitter     = ChidoriTrailEmitter;

   brickExplosionRadius = 3;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 100;             
   brickExplosionMaxVolume = 29;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 39;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 100;
   fadeDelay           = 35;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.2 0.5 1.0";

   uiName = "Chidori";
};

////////
//Item//
////////

datablock ItemData(ChidoriItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Chidori";
	iconName = "./ChidoriIcon";
	doColorShift = false;
	colorShiftColor = "0.1 0.12 0.0 1.2";

	 // Dynamic properties defined by the scripts
	image = ChidoriImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ChidoriImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = ChidoriProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = CobraItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTransitionOnTriggerDown[0]  = "Fire";
	stateAllowImageChange[0]	   = true;
	stateSound[0]			   = weaponSwitchSound;
	stateTransitionOnTimeout[0]	   = "Ready";
	stateTimeoutValue[0]		   = 0.01;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateTimeoutValue[1]		   = 0.04;
	stateTransitionOnTimeout[1]	   = "Ready";
	stateWaitForTimeout[1]		   = true;
	stateAllowImageChange[1]	   = true;
	stateEmitter[1]			   = ChidoriSparkEmitter;
	stateEmitterTime[1]		   = 0.07;

	stateName[2]                     = "Fire";
	stateTransitionOnTriggerUp[2]	   = "wait";
	stateTransitionOnTimeout[2]	   = "Fire";
	stateTimeoutValue[2]		   = 0.04;
	stateWaitForTimeout[2]		   = true;
	stateFire[2]			   = true;
	stateAllowImageChange[2]	   = true;
	//stateSound[2]			   = ChidoriFireSound;
	stateScript[2]			   = "onFire";
	stateEmitter[2]			   = ChidoriSparkEmitter;
	stateEmitterTime[2]		   = 0.07;
	stateSequence[2]			   = "fire";

	stateName[3] 			   = "wait";
	stateTransitionOnTimeout[3]	   = "Ready";
	stateWaitForTimeout[3]		   = true;
	stateAllowImageChange[3]	   = true;
	stateSequence[3]			   = "wait";
};






